;Main program to test the TEA routines. Calling TEAdec after TEAenc with
;the same 'ka'...'kd' should give the original 'vy' and 'vz' values. 


	list	p=PIC16F84, r=dec

	include	"p16f84.inc"

	include "math32.inc"

	cblock	0x0c		;Dummy block to set the start of usable memory
	endc


	org	0		;Code start

test	mmovl32	vy, 0x00000000	;Set the plaintext
	mmovl32	vz, 0x00000000

	mmovl32	ka, 0x00000000	;Set the key
	mmovl32	kb, 0x00000000
	mmovl32	kc, 0x00000000
	mmovl32	kd, 0x00000000

	call	TEAenc		;Encipher...
	call	TEAdec		;...and decipher.
	goto	test		;Once again!


	include	"tea.asm"	;Include the TEA routines


	end
